include "Zeropage.inc"
include 'map.inc'
include "Chars.inc"

ext	Stages, Stage.Count, TimeRate
ext Man.Init
ext Kn.Init
ext Mon.Init
ext Put2x2

dseg
stage		defb	0
public stage
map.width	defb	0
map.height	defb	0
public map.width,map.height
stage.width		defb	0
stage.height	defb	0
goal.x defb 0
goal.y defb 0
public goal.x,goal.y
Stage.Time defw 0 | public Stage.Time
blink defb 0
Stage.Clear defb 0 | public Stage.Clear
stage.offset defb 0 | public stage.offset
stage.byte defb 0
stage.bitCount defb 0
map.mask defb 0
map.bits defb 0
map	defs map.size
public map

cseg

ToMapSize: public ToMapSize
    sta <ZB4
    asl a
    clc
    adc <ZB4
    adc #1
rts

RotBit:
	asl map.mask
	if eq
        lda map.bits
        ldx #0
		sta (<ZW1,x)
        lda <ZW1.low
        clc
        adc #1
        sta <ZW1.low
        lda <ZW1.high
        adc #0
        sta <ZW1.high
        inc map.mask
        lda #0
        sta map.bits
	endif
rts

RotBit2:
	asl map.mask
	if eq
        lda map.bits
        ldx #0
		sta (<ZW1,x)
        ldy #map.step
		sta (<ZW1),y
        lda <ZW1.low
        clc
        adc #1
        sta <ZW1.low
        lda <ZW1.high
        adc #0
        sta <ZW1.high
        inc map.mask
        lda #0
        sta map.bits
	endif
rts


InitMap: public	InitMap
    lda #low map
    sta <ZW0.low
    lda #high map
    sta <ZW0.high
    lda #map.max.height
    sta <ZB0
    do
        lda #map.step
        sta <ZB1
        lda #0
        ldx #0
        do
            sta [<ZW0,x]
            inc <ZW0.low
            if eq
                inc <ZW0.high
            endif
            dec <ZB1
        while ne | wend
        dec <ZB0
    while ne | wend

    lda #10
    sta TimeRate
    lda #low Stage.Count
    sta <ZB4
    lda stage
    do
        sec
        sbc #low Stage.Count
    while cs
        dec TimeRate
    wend
    lda TimeRate
    cmp #2
    if cc
        lda #2
        sta TimeRate
    endif

    lda #low Stages
    sta <ZW0.low
    lda #high Stages
    sta <ZW0.high
    lda stage
    and #15
    asl a
    tay
    lda (<ZW0),y
    sta <ZW2.low
    iny
    lda (<ZW0),y
    sta <ZW2.high
    ldy #0

    lda (<ZW2),y
    iny
    sta stage.width
    jsr ToMapSize
    sta map.width
    lda (<ZW2),y
    iny
    sta stage.height
    jsr ToMapSize
    sta map.height

    sty stage.offset
    lda #low map
    sta <ZW0.low
    sta <ZW1.low
    lda #high map
    sta <ZW0.high
    sta <ZW1.high
    lda map.width
    sta <ZB4
    lda #1
    sta map.mask
    lda #0
    sta map.bits
    do
        lda map.bits
        ora map.mask
        sta map.bits
        jsr RotBit
        dec <ZB4
    while ne | wend
    lda map.bits
    ldx #0
    sta (<ZW1,x)
    
    lda <ZW0.low
    clc
    adc #map.step
    sta <ZW0.low
    sta <ZW1.low
    lda <ZW0.high
    adc #0
    sta <ZW0.high
    sta <ZW1.high

    ldy stage.offset
    lda (<ZW2),y
    iny
    sty stage.offset
    sta stage.byte
    lda #8
    sta stage.bitCount
    lda stage.height
    sta <ZB0
    do
        lda #1
        sta map.mask
        sta map.bits
        jsr RotBit2
        lda stage.width
        sta <ZB1
        do
            jsr RotBit2
            jsr RotBit2
            lda stage.byte
            and #1
            if ne
                lda map.bits
                ora map.mask
                sta map.bits
            endif
            jsr RotBit2
            lsr stage.byte
            dec stage.bitCount
            if eq
                ldy stage.offset
                lda (<ZW2),y
                iny
                sty stage.offset
                sta stage.byte
                lda #8
                sta stage.bitCount
            endif
            dec <ZB1
        while ne | wend
        lda map.bits
        ldx #0
        sta (<ZW1,x)
        ldy #map.step
        sta (<ZW1),y
        
        lda <ZW0.low
        clc
        adc #map.step*2
        sta <ZW0.low
        sta <ZW1.low
        lda <ZW0.high
        adc #0
        sta <ZW0.high
        sta <ZW1.high

        lda #1
        sta map.mask
        sta map.bits
        jsr RotBit
        lda stage.width
        sta <ZB1
        do
            lda stage.byte
            and #1
            if ne
                lda map.bits
                ora map.mask
                sta map.bits
                jsr RotBit
                lda map.bits
                ora map.mask
                sta map.bits
                jsr RotBit
            else
                jsr RotBit
                jsr RotBit
            endif
            lda map.bits
            ora map.mask
            sta map.bits
            jsr RotBit
            lsr stage.byte
            dec stage.bitCount
            if eq
                ldy stage.offset
                lda (<ZW2),y
                iny
                sty stage.offset
                sta stage.byte
                lda #8
                sta stage.bitCount
            endif
            dec <ZB1
        while ne | wend
        lda map.bits
        ldx #0
        sta (<ZW1,x)
        
        lda <ZW0.low
        clc
        adc #map.step
        sta <ZW0.low
        sta <ZW1.low
        lda <ZW0.high
        adc #0
        sta <ZW0.high
        sta <ZW1.high

        dec <ZB0
    while ne | wend

    lda stage.bitCount
    cmp #8
    if eq
        ldy stage.offset
        dey
        sty stage.offset
    endif

    jsr Man.Init
    
    ldy stage.offset
    lda (<ZW2),y | iny | jsr ToMapSize | sta goal.x
    lda (<ZW2),y | iny | jsr ToMapSize | sta goal.y
    sty stage.offset
    jsr Kn.Init
    jsr Mon.Init
    ; time
    ldy stage.offset
    lda (<ZW2),y | iny | sta Stage.Time
    lda (<ZW2),y | iny | sta Stage.Time+1
rts


MapAddress:
    lda <ZB3
    sta <ZW0.low
    lda #0
    sta <ZW0.high
    asl <ZW0.low | rol <ZW0.high  ; *2
    asl <ZW0.low | rol <ZW0.high  ; *4
    asl <ZW0.low | rol <ZW0.high  ; *8 : map.step
    lda <ZW0.low | clc | adc #low map | sta <ZW0.low
    lda <ZW0.high | adc #high map | sta <ZW0.high

    lda <ZB2
    lsr a   ; /2
    lsr a   ; /4
    lsr a   ; /8
    clc | adc <ZW0.low | sta <ZW0.low
    lda <ZW0.high | adc #0 | sta <ZW0.high
rts


Tst2x2:  public Tst2x2
    jsr MapAddress

    lda #3 | sta <ZW1.low
    lda #0 | sta <ZW1.high

    lda <ZB2
    and #7
    do | while ne
        asl <ZW1.low | rol <ZW1.high
        sec | sbc #1
    wend

    lda #2 | sta <ZB4
    do
        ldy #0
        lda (<ZW0),y
        and <ZW1.low
        bne Tst2x2_Exit
        iny
        lda (<ZW0),y
        and <ZW1.high
        bne Tst2x2_Exit

        lda <ZW0.low | clc | adc #map.step | sta <ZW0.low
        lda <ZW0.high | adc #0 | sta <ZW0.high

        dec <ZB4
    while ne | wend
Tst2x2_Exit:
rts


Tst1x1:  public Tst1x1
    jsr MapAddress

    lda #1 | sta <ZB4

    lda <ZB2
    and #7
    do | while ne
        asl <ZB4
        sec | sbc #1
    wend

    ldy #0 | lda (<ZW0),y
    and <ZB4
rts


Goal.Draw: public Goal.Draw
    inc blink
    lda blink
    and #1
    if ne
        lda goal.x | sta <ZB2
        lda goal.y | sta <ZB3
        lda #Char_Goal | sta <ZB4
        jsr Put2x2
    endif
rts