include "Chars.inc"
include "Zeropage.inc"

count equ 8

;offsets
xPos equ 0
yPos equ 1
type equ 2
status equ 3
clock equ 4
unitSize equ 5

status.none equ 0
status.live equ 1
status.die equ 2
type.horizontal equ 0
type.vertical equ 1
type.chase equ 2

dseg
monsters defs unitSize * count
public monsters
current defw 0
current.Hi equ current
current.Lo equ current+1
hits defb 0

ext ToMapSize, Tst2x2
ext stage.offset
ext man.x, man.y, man.status.die
ext Put2x2

cseg

Mon.Init: public Mon.Init
    ldy stage.offset
    lda (<ZW2),y | iny
    sta <ZB0

    ldx #0
    lda #count
    sta <ZB1
    do
        lda (<ZW2),y | iny
        jsr ToMapSize
        sta monsters+xPos,x
        
        lda (<ZW2),y | iny
        pha
            and #$3f
            jsr ToMapSize
            sta monsters+yPos,x
        pla
        lsr a
        lsr a
        lsr a
        lsr a
        lsr a
        lsr a
        sta monsters+type,x

        lda #status.live
        sta monsters+status,x

        txa | clc | adc #unitSize | tax
        dec <ZB1
        dec <ZB0
    while ne | wend
    sty stage.offset

    lda <ZB1
    do | while ne
        lda #status.none
        sta monsters+status,x

        txa | clc | adc #unitSize | tax
        dec <ZB1
    wend
rts


Mon.Move:   public Mon.Move
    ldx #0
    lda #count
    do
        pha
            inc monsters+clock,x
            lda monsters+status,x
            beq Move.Next
            cmp #status.live
            if eq
                jsr TestHit.Man
                lda monsters+type,x
                if eq
                    ; type.horizontal
                    lda monsters+xPos,x
                    cmp man.x
                    beq Move.Next
                    if cc
                        adc #1
                    else
                        sbc #1
                    endif
                    sta <ZB2
                    lda monsters+yPos,x
                    sta <ZB3
                    jmp TryToMove
                endif
                cmp #type.vertical
                if eq
                    lda monsters+yPos,x 
                    cmp man.y
                    beq Move.Next
                    if cc
                        adc #1
                    else
                        sbc #1
                    endif
                    sta <ZB3
                    lda monsters+xPos,x
                    sta <ZB2
                    TryToMove:
                    jsr TestMove
                    bne Move.Next
                    CanMove:
                    lda <ZB2
                    sta monsters+xPos,x
                    lda <ZB3
                    sta monsters+yPos,x
                    jsr TestHit.Man
                    jmp Move.Next
                endif
                cmp #type.chase
                if eq
                    lda monsters+clock,x
                    and #1
                    beq Move.Next

                    lda monsters+xPos,x
                    sta <ZB2
                    lda monsters+yPos,x
                    sta <ZB3
                    lda man.x
                    cmp <ZB2
                    if ne
                        if cc
                            dec <ZB2
                        else
                            inc <ZB2
                        endif
                        jsr TestMove
                        beq CanMove
                        lda monsters+xPos,x
                        sta <ZB2
                    endif
                    lda man.y
                    cmp <ZB3
                    beq Move.Next
                    if cc
                        dec <ZB3
                    else
                        inc <ZB3
                    endif
                    jsr TestMove
                    beq CanMove
                    jmp Move.Next
                endif
            endif
            cmp #status.die
            if eq
                lda monsters+clock,x
                cmp #4
                if eq
                    lda #status.none
                    sta monsters+status,x
                endif
            endif
            Move.Next:
            txa | clc | adc #unitSize | tax
        pla
        sec | sbc #1
    while ne | wend
rts


TestMove: public TestMove
    jsr Tst2x2
    stx <ZB4
    if eq
        ldy #0
        lda #count
        sta <ZB0
        do
            cpy <ZB4
            if ne
                lda monsters+status,y
                cmp #status.live
                if eq
                    lda <ZB2
                    sec | sbc monsters+xPos,y
                    clc | adc #1
                    cmp #3
                    if cc
                        lda <ZB3
                        sec | sbc monsters+yPos,y
                        clc | adc #1
                        cmp #3
                        if cc
                            lda #1;  z := 0
                            rts
                        endif
                    endif
                endif
            endif
            tya | clc | adc #unitSize | tay
            dec <ZB0
        while ne | wend
        lda #0 ; z := 1
    endif
rts


TestHit.Man:
    lda man.x
    sec | sbc monsters+xPos,x
    clc | adc #1
    cmp #3
    if cc
        lda man.y
        sec | sbc monsters+yPos,x
        clc | adc #1
        cmp #3
        if cc
            inc Man.Status.Die
        endif
    endif
rts


Mon.Draw:   public Mon.Draw
    ldx #0
    lda #count
    do
        pha
            lda monsters+status,x
            beq DrawNext
            cmp #status.live
            if eq
                lda monsters+type,x
                cmp #type.chase
                if eq
                    lda #Char_Chaser
                    jmp put
                endif
                lda #Char_Disturber
                jmp put
            endif
            cmp #status.die
            if eq
                lda #Char_Bang
                put:
                sta <ZB4
                lda monsters+xPos,x
                sta <ZB2
                lda monsters+yPos,x
                sta <ZB3
                jsr Put2x2
            endif
            DrawNext:
            txa | clc | adc #unitSize | tax
        pla
        sec | sbc #1
    while ne | wend
rts


ext AddScore
Mon.TestHit.Kn: public Mon.TestHit.Kn
    ldx #0
    stx hits
    lda #count
    do  
        pha
            lda monsters+status,x
            cmp #status.live
            if eq
                lda <ZB2
                sec | sbc monsters+xPos,x
                beq hit_x
                cmp #1
                if eq
                    hit_x:
                    lda <ZB3
                    sec | sbc monsters+yPos,x
                    beq hit_y
                    cmp #1
                    if eq
                        hit_y:
                        lda #status.die
                        sta monsters+status,x
                        lda #0
                        sta monsters+clock,x
                        inc hits
                        lda monsters+type,x
                        cmp #type.chase
                        if eq
                            lda #30 ; 300 Pts.
                        else
                            lda #10 ; 
                        endif
                        jsr AddScore
                    endif
                endif
            endif
            txa | clc | adc #unitSize | tax
        pla
        sec | sbc #1
    while ne | wend
    lda hits
rts